// -*- mode: c++ -*-
#include "key-classes.h"

ColorKeymaps(

#if defined (PRIMARY_KEYMAP_QWERTY)
  [PRIMARY] = KEYMAP_STACKED
  (CK(___,Base),          CK(Key_1,Base), CK(Key_2,Base), CK(Key_3,Base), CK(Key_4,Base), CK(Key_5,Base), CK(Key_LEDEffectNext,Base),
   CK(Key_Backtick,Base), CK(Key_Q,Base), CK(Key_W,Base), CK(Key_E,Base), CK(Key_R,Base), CK(Key_T,Base), CK(Key_Tab,Base),
   CK(Key_PageUp,Base),   CK(Key_A,Base), CK(Key_S,Base), CK(Key_D,Base), CK(Key_F,Base), CK(Key_G,Base),
   CK(Key_PageDown,Base), CK(Key_Z,Base), CK(Key_X,Base), CK(Key_C,Base), CK(Key_V,Base), CK(Key_B,Base), CK(Key_Escape,Base),
   CK(Key_LeftControl,Base), CK(Key_Backspace,Base), CK(Key_LeftGui,Base), CK(Key_LeftShift,Base),
   CK(M(MACRO_FVWM),Base),

   CK(M(MACRO_ANY),Base),   CK(Key_6,Base), CK(Key_7,Base), CK(Key_8,Base),     CK(Key_9,Base),      CK(Key_0,Base),         CK(M(MACRO_NUMLOCK),Base),
   CK(Key_Enter,Base),      CK(Key_Y,Base), CK(Key_U,Base), CK(Key_I,Base),     CK(Key_O,Base),      CK(Key_P,Base),         CK(Key_Equals,Base),
                            CK(Key_H,Base), CK(Key_J,Base), CK(Key_K,Base),     CK(Key_L,Base),      CK(Key_Semicolon,Base), CK(Key_Quote,Base),
   CK(Key_RightAlt,Base),   CK(Key_N,Base), CK(Key_M,Base), CK(Key_Comma,Base), CK(Key_Period,Base), CK(Key_Slash,Base),     CK(Key_Minus,Base),
   CK(Key_RightShift,Base), CK(Key_LeftAlt,Base), CK(Key_Spacebar,Base), CK(Key_RightControl,Base),
   CK(ShiftToLayer(FUNCTION),Base)),

#elif defined (PRIMARY_KEYMAP_DVORAK)

  [PRIMARY] = KEYMAP_STACKED
  (CK(___,Base),          CK(Key_1,Base),         CK(Key_2,Base),     CK(Key_3,Base),      CK(Key_4,Base), CK(Key_5,Base), CK(Key_LEDEffectNext,Base),
   CK(Key_Backtick,Base), CK(Key_Quote,Base),     CK(Key_Comma,Base), CK(Key_Period,Base), CK(Key_P,Base), CK(Key_Y,Base), CK(Key_Tab,Base),
   CK(Key_PageUp,Base),   CK(Key_A,Base),         CK(Key_O,Base),     CK(Key_E,Base),      CK(Key_U,Base), CK(Key_I,Base),
   CK(Key_PageDown,Base), CK(Key_Semicolon,Base), CK(Key_Q,Base),     CK(Key_J,Base),      CK(Key_K,Base), CK(Key_X,Base), CK(Key_Escape,Base),
   CK(Key_LeftControl,Base), CK(Key_Backspace,Base), CK(Key_LeftGui,Base), CK(Key_LeftShift,Base),
   CK(M(MACRO_FVWM),Base),

   CK(M(MACRO_ANY),Base),   CK(Key_6,Base), CK(Key_7,Base), CK(Key_8,Base), CK(Key_9,Base), CK(Key_0,Base), CK(LockLayer(NUMPAD),Base),
   CK(Key_Enter,Base),      CK(Key_F,Base), CK(Key_G,Base), CK(Key_C,Base), CK(Key_R,Base), CK(Key_L,Base), CK(Key_Slash,Base),
                            CK(Key_D,Base), CK(Key_H,Base), CK(Key_T,Base), CK(Key_N,Base), CK(Key_S,Base), CK(Key_Minus,Base),
   CK(Key_RightAlt,Base),   CK(Key_B,Base), CK(Key_M,Base), CK(Key_W,Base), CK(Key_V,Base), CK(Key_Z,Base), CK(Key_Equals,Base),
   CK(Key_RightShift,Base), CK(Key_LeftAlt,Base), CK(Key_Spacebar,Base), CK(Key_RightControl,Base),
   CK(ShiftToLayer(FUNCTION),Base)),

#else

#error "No default keymap defined. You should make sure that you have a line like '#define PRIMARY_KEYMAP_QWERTY' in your sketch"

#endif



  [NUMPAD] =  KEYMAP_STACKED
  (CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(___,Off),
   CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off),
   CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off),
   CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off), CK(XXX,Off),
   CK(___,Off), CK(___,Off), CK(___,Off), CK(___,Off),
   CK(___,Off),

   CK(M(MACRO_VERSION_INFO),Base), CK(XXX,Off), CK(Key_Keypad7,Num), CK(Key_Keypad8,Num),   CK(Key_Keypad9,Num),        CK(Key_KeypadSubtract,Num), CK(___,NumBreathe),
   CK(XXX,Off),                    CK(XXX,Off), CK(Key_Keypad4,Num), CK(Key_Keypad5,Num),   CK(Key_Keypad6,Num),        CK(Key_KeypadAdd,Num),      CK(XXX,Off),
                                   CK(XXX,Off), CK(Key_Keypad1,Num), CK(Key_Keypad2,Num),   CK(Key_Keypad3,Num),        CK(Key_KeypadEquals,Num),   CK(XXX,Off),
   CK(XXX,Off),                    CK(XXX,Off), CK(Key_Keypad0,Num), CK(Key_KeypadDot,Num), CK(Key_KeypadMultiply,Num), CK(Key_KeypadDivide,Num),   CK(Key_KeypadEnter,Num),
   CK(___,Off), CK(___,Off), CK(___,Off), CK(___,Off),
   CK(___,Off)),

  [FUNCTION] =  KEYMAP_STACKED
  (CK(XXX,Off),        CK(Key_F1,Func),           CK(Key_F2,Func),      CK(Key_F3,Func),   CK(Key_F4,Func),       CK(Key_F5,Func),          CK(___,Off),
   CK(Key_Tab,Func2),  CK(XXX,Off),               CK(Key_mouseUp,Ms),   CK(XXX,Off),       CK(Key_mouseBtnR,MsB), CK(Key_mouseWarpEnd,MsW), CK(Key_mouseWarpNE,MsW),
   CK(Key_Home,Func2), CK(Key_mouseL,Ms),         CK(Key_mouseDn,Ms),   CK(Key_mouseR,Ms), CK(Key_mouseBtnL,MsB), CK(Key_mouseWarpNW,MsW),
   CK(Key_End,Func2),  CK(Key_PrintScreen,Func2), CK(XXX,Off),          CK(XXX,Off),       CK(Key_mouseBtnM,MsB), CK(Key_mouseWarpSW,MsW),  CK(Key_mouseWarpSE,MsW),
   CK(___,Off), CK(Key_Delete,Func2), CK(___,Off), CK(___,Off),
   CK(___,Off),

   CK(XXX,Off),                 CK(Key_F6,Func),         CK(Key_F7,Func),                CK(Key_F8,Func),                 CK(Key_F9,Func),           CK(Key_F10,Func),           CK(Key_F11,Func),
   CK(XXX,Off),                 CK(XXX,Off),             CK(Key_LeftCurlyBracket,Base2), CK(Key_RightCurlyBracket,Base2), CK(Key_LeftBracket,Base2), CK(Key_RightBracket,Base2), CK(Key_F12,Func),
                                CK(Key_LeftArrow,Base2), CK(Key_DownArrow,Base2),        CK(Key_UpArrow,Base2),           CK(Key_RightArrow,Base2),  CK(XXX,Off),                CK(XXX,Off),
   CK(Key_PcApplication,Func2), CK(XXX,Off),             CK(XXX,Off),                    CK(XXX,Off),                     CK(XXX,Off),               CK(Key_Backslash,Base2),    CK(Key_Pipe,Base2),
   CK(___,Off), CK(___,Off), CK(Key_Insert,Func2), CK(___,Off),
   CK(___,Off)),

  [FVWM] =  KEYMAP_STACKED
  (CK(XXX,Off),                 CK(Key_BacklightDown,Screen), CK(Key_BacklightUp,Screen), CK(Key_F1,Lnch),      CK(Key_F2,Lnch),      CK(XXX,Off),                 CK(___,Off),
   CK(XXX,Off),                 CK(XXX,Off),                  CK(XXX,Off),                CK(XXX,Off),          CK(XXX,Off),          CK(XXX,Off),                 CK(Key_Tab,Wind),
   CK(Key_KeypadAdd,Wind),      CK(XXX,Off),                  CK(Key_Keypad4,Wind),       CK(Key_Keypad2,Wind), CK(Key_Keypad8,Wind), CK(Key_Keypad6,Wind),
   CK(Key_KeypadSubtract,Wind), CK(XXX,Off),                  CK(XXX,Off),                CK(XXX,Off),          CK(XXX,Off),          CK(Key_KeypadMultiply,Wind), CK(___,Off),
   CK(___,Off), CK(Key_Backtick,Lnch),  CK(LSHIFT(Key_Backtick),Lnch), CK(___,Off),
   CK(___,Off),

   CK(Key_W,Wind),     CK(Consumer_Mute,Media), CK(Consumer_VolumeDecrement,Media), CK(Consumer_VolumeIncrement,Media), CK(XXX,Off),             CK(Key_F10,Media), CK(___,Off),
   CK(XXX,Off),        CK(XXX,Off),             CK(XXX,Off),                        CK(XXX,Off),                        CK(XXX,Off),             CK(XXX,Off),       CK(LSHIFT(Key_KeypadDivide),Wind),
                       CK(Key_LeftArrow,View),  CK(Key_DownArrow,View),             CK(Key_UpArrow,View),               CK(Key_RightArrow,View), CK(XXX,Off),       CK(LSHIFT(Key_KeypadEnter),Wind),
   CK(Key_Pause,Lnch), CK(XXX,Off),             CK(XXX,Off),                        CK(XXX,Off),                        CK(XXX,Off),             CK(Key_M,Wind),    CK(LSHIFT(Key_KeypadDot),Wind),
   CK(___,Off), CK(___,Off), CK(___,Off), CK(___,Off),
   CK(___,Off))
);
